# Calculate price
Source: https://docs.corrily.com/api-reference/calculate-price
POST https://client.corrily.com/v1/prices
Calculate a localized or optimized price for your service or product based on the customer's location and other characteristics.
## Usage
The first time that you call this endpoint for a given IP address and user ID, Corrily calculates the price. On subsequent calls (with the same IP address and user ID), Corrily returns the original calculated price.
See [Calculate price API examples](../pricing/calculate-price-api-examples) for examples of how this endpoint is commonly used.
### Price localization
If you're only using Corrily for price localization (i.e. you are not doing price optimization), this is the endpoint that you call in order to get localized prices.
### Price optimization
If you're also doing price optimization, this is the endpoint you call to get optimized prices.
As explained in [Price optimization overview](../pricing/price-optimization-overview), Corrily either returns an experimental price or a control price which will be used to benchmark the experimental prices.
Experimental prices are affected by the following factors:
* The (potential) customer's location, which is inferred from their IP address
* Any [user features](../users/02_user-features) that you have provided
* The outcomes of previous price experiments
* The upper and lower bounds that you defined in the Corrily Dashboard
## Body Params
A [User ID](../users/01_users). Only required if no `ip` is provided and
`get_ip_from_request` is `false`.
The product IDs that you want to calculate prices for. In general, you
probably want to include the product IDs for all the product offerings that
you intend to show your visitor. The response from Corrily will contain the
display price for each product. For example, if you provide `["monthly",
"annual"]`, Corrily returns price data for your `monthly` and `annual`
products. Product IDs are created by Corrily when you set up your Corrily
account. Email [support@corrily.com](mailto:support@corrily.com) if you don't know yours.
If packaging segmentation is enabled, package id can be passed to get the products for a package. That way
the products shown themselves will be based on the package segmentation.
When package segmentation is enabled, the products parameter is optional.
If there is no pacakge segmentation defined for given country, audience, and no package\_id, products
are specified in request, an error will be returned.
An IPv4 or IPv6 address. Corrily uses this as the user ID if no user\_id is
provided. ip is only required if no user\_id is provided and
`get_ip_from_request` is false. Examples: `187.106.3.73` (IPv4),
`2804:14d:ac91:8286:efcb:851f:b59f:fffc` (IPv6).
If `true`, Corrily sources the user's IP from this request.
`get_ip_from_request` therefore only works correctly when the Corrily API
request is made from a client device.
A two-letter (Alpha-2) [ISO 3166 country
code](https://en.wikipedia.org/wiki/List_of_ISO_3166_country_codes#Current_ISO_3166_country_codes).
Example: `US`
An object containing key-value pairs of arbitrary strings that represent features of this user which may affect their optimal price. See [User features](../users/02_user-features). Example: `{"platform": "ios"}`
The payment gateways to return integration objects for. Accepted values:
`stripe`, `paypal`, `chargebee`
A currency you wish the price to be tied to. Currencies do not need to match
the passed country. For example, it is possible to return a price in EUR for
someone based in the Unites Sates. Note that the country-adjusted price will
be returned, regardless of the currency set.
With this flag you can run a complete recomputation of what should be shown for a user: country, currency, experiment and arm.
For example, if a user was attached to country A and now you want to attach him to country B, and recompute products and prices for him,
then you can use this flag. After recomputation, all previously saved for this user data will be overrided.
Will override the currency of any previously saved price and instead return
the price in the currency provided. If set to `true`, a `currency` param must
be passed. Unlike `override` the price amount will *not* be recomputed.
If set to false, will make sure no experiment is run.
Optional product id to coupon id mapping to explicitly specify the coupon to be applied in the pricing. Coupons feature needs to be enabled for this. example `{"product_id_1": "coupon_id_1"}`. Multiple coupons can be applied by a comma-delimited string, for example: `{"product_id_1": "coupon_id_1,coupon_id2"}`
## Response
Whether or not the request completed successfully.
The user ID that you provided when you called calculate price, or the user's
IP address (if you did not provide a user ID).
The country that the price data is associated to. If you did not specify a
country when calling calculate price, the `country` value provided here in the
response is inferred from the user's IP address.
The currency that the price data is associated to. Tip: check if `products. {id}.display.price` meets your needs before manually constructing a display price
with this field.
The currency symbol that the price data is associated to. Tip: check if
`products.{id}.display.price` meets your needs before manually constructing a
display price with this field.
The package ID that was used to get the products.
The price data for each of the products that you specified when you called calculate price. The placeholder `{id}` below represents your product ID(s). See [Setup](../basics/setup) to learn how to create product IDs.
A float version of your price, in case you want to do some custom formatting of the price. Tip: check if `products.{id}.display.price` meets your needs before manually constructing a display price with this field.
The current value of `products.{id}.price` in United States dollars.
The billing interval of this product. Possible values: `day`, `week`, `month`, `year`, `one_time`
The price data, formatted in various ways for display to your user.
The price data, formatted in a way that your user will quickly understand. This is usually a combination of `currency`, `currency_symbol`, and `products.{id}.price`. `products.{id}.price` will use commas or periods as separators if that is the local custom. Example: `JP¥2,200`
The default price for the product. You can set this default price in your Corrily Dashboard.
If `products.{id}.price` is an experimental price, this field contains the baseline price striked out, followed by the experimental price. You may want to present this to your user to help them see that they would be paying less than normal customers. Example: $̶3̶4̶ $19
If `products.{id}.price` is an experimental price, this field contains the percentage discount of the experimental price compared to the baseline price. For example, if the baseline price is 34 and the experimental price is 19, the discount is about 44%: 1 - (19 ÷ 34)) × 100
The trial data for the product if available
The corrily trial id for the product
Number of days for the trial
Type of the trial. Possible values: `PAID`, `FREE`
The price data, formatted for payment gateway integration.
The currency that `products.{id}.integrations.{gateway}.amount` is priced in. If this currency is not the same as the top-level `currency` value in this response (the "local currency"), it means that the payment gateway does not accept the local currency.
The amount that you should pass to the payment gateway when creating the
subscription or charge. Many payment gateways use [smallest-unit currency
format](../payment-gateways/integration-guide#map-smallest-unit-currency-format-to-decimal-format)
in which case this value will be an integer.
As mentioned in `products.{id}.integrations.{gateway}.currency`, sometimes a
payment gateway doesn't support your user's local currency. If that's the
case, then `products.{id}.integrations. {gateway}.formatted` provides the equivalent price in a currency that the payment
gateway does support. This field is similar to `products.{id}.display.price` in
that it will be formatted in a way that your user will quickly understand.
Optionally include coupon details if the given request matches any segment for
which an active campaign is running
coupon id
coupon corrily api\_id
indicates if a coupon is percentage discount coupon or absolute amount
discount coupon
The value or percentage or absolute amount of discount for the coupon
Array of strings. Indicates sources of the coupon if the coupon maps to external
sources. For example: "coupon\_source": \["STRIPE", "CHARGEBEE"]
External Coupon corrily id
Coupon id from the external source if that coupon maps to an external
source
Indicates currency code if it is configured for the coupon
Datetime in YYYY-MM-DD HH:MM:SS format. Indicates the time the coupon is
valid for in UTC.
The price data after coupon application, formatted in various ways for display to your user.
The price data in a useful format after coupon application.
This value is formatted in the same way as `products.{id}.price`.
Uses `coupons[i].display.price_numeric` as a price source.
Numeric price after coupon application
The default price for the product. You can set this default price in your Corrily Dashboard.
`reference_interval_price` in numeric format
If `products.{id}.price` is an experimental price, this field contains the baseline price striked out, followed by the experimental price. You may want to present this to your user to help them see that they would be paying less than normal customers. Example: $̶3̶4̶ $19
If coupon is in percents, then here will be coupon value in percents.
If coupon is absolue value, then this field will contain relation in percents between base price and price after coupon is applied.
Price after coupon application
Price experimentation metadata. If you are not doing price experimentation,
you can ignore this object.
Whether or not this response contains experimental prices.
The ID of this experiment. An id of `0` means no experiment was run.
One of `price`, `packaging` or `null`.
In the case of a `packaging` experiment, the product API IDs to pick from
the `product` object of the response to show to users.
The experiment arm identifier, equal to `baseline` if experiment is run
but baseline arm was selected.
The first audience user matches.
Audience name
Audience API ID
All audiences user matches, sorted by name.
Audience name
Audience API ID
```json Example theme={null}
{
"success": true,
"user_id": "193.37.32.232",
"country": "SG",
"currency": "SGD",
"currency_symbol": "S$",
"products": {
"monthly": {
"price": 27,
"price_usd": 20.059360849328197,
"interval": "month",
"interval_count": 1,
"display": {
"price": "S$ 27",
"reference_interval_price": "S$ 27",
"price_with_baseline_strike": "S$ 27",
"discount_to_baseline": 0
},
"integrations": {
"stripe": {
"currency": "SGD",
"amount": 2700,
"formatted": "S$ 27"
}
}
},
"annual": {
"price": 144,
"price_usd": 106.98325786308372,
"interval": "year",
"interval_count": 1,
"display": {
"price": "S$ 144",
"reference_interval_price": "S$ 12",
"price_with_baseline_strike": "S$ 12",
"discount_to_baseline": 0
},
"integrations": {
"stripe": {
"currency": "SGD",
"amount": 14400,
"formatted": "S$ 144"
}
},
"coupon": {
"id": "coupon_id_392",
"type": "percentage",
"value": 10,
"coupon_source": "chargebee",
"external_coupon_id": "chargebee_coupon_392",
"currency_code": "USD",
"valid_till": "2022-02-07 15:49:49",
"display": {
"local_currency_symbol": "€",
"interval_local_price_formatted": "9 €",
"local_price_formatted": "9 €",
"usd_price_formatted": "$11",
"local_price_formatted_with_baseline_strike": "9 €",
"pct_discount_to_baseline": 0.0
}
}
}
},
"variants": {
"experimented_on": false,
"experiment_id": 0,
"treatment_group": null,
"experiment_type": null,
"arm_id": 0,
"products_to_select": []
},
"audience": {
"name": "First Audience",
"api_id": "audience_1"
},
"matching_audiences": [
{
"name": "First Audience",
"api_id": "audience_1"
},
{
"name": "Second Audience",
"api_id": "audience_2"
}
],
}
```
```bash Bash theme={null}
curl --request POST \
--url https://client.corrily.com/v1/prices \
--header 'Content-Type: application/json' \
--data '
{
"user_id": "string",
"products": [
"string"
],
"ip": "string",
"get_ip_from_request": true,
"country": "string",
"integrations": [
"string"
],
"currency": "string",
"override": true,
"run_experiment": true
}
'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url = "https://client.corrily.com/v1/prices";
const options = {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify({
user_id: "string",
products: ["string"],
ip: "string",
get_ip_from_request: true,
country: "string",
integrations: ["string"],
currency: "string",
override: true,
run_experiment: true,
}),
};
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/prices"
payload = {
"user_id": "string",
"products": ["string"],
"ip": "string",
"get_ip_from_request": True,
"country": "string",
"integrations": ["string"],
"currency": "string",
"override": True,
"run_experiment": True
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
```
# Create charge
Source: https://docs.corrily.com/api-reference/create-charge
POST https://client.corrily.com/v1/charges
Notify Corrily that one of your customers has initiated a one-time transaction.
```bash Bash theme={null}
curl --request POST \
--url https://client.corrily.com/v1/charges \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data '
{
"amount": 50,
"amount_refunded": 0,
"created": 1662444537,
"currency": "USD",
"country": "US",
"origin": "stripe",
"origin_id": "sub_JaHy9Kl6ZMLvId",
"product": "monthly",
"status": "succeeded",
"user_id": "test_user"
}
'
```
Custom payment gateway integrations only
You do not need to use this endpoint if you have [granted Corrily automated
access](../payment-gateways/integration-guide#recommended-provide-automated-access-of-subscription-and-charge-events)
to your payment gateway's subscription and charge events.
## Body Params
The amount (price) of the charge.
The amount refunded by the charge. Only required if amount is undefined.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the charge was created. This timestamp should represent when
the charge was initialized, regardless of the status of the charge during the
initialization. It's rare to need to update `created` after initially setting
it.
The three-letter [(ISO
4217\)](https://en.wikipedia.org/wiki/ISO_4217#Active_codes) currency code.
User's two-letter ISO3166 country code.
The payment gateway that handled the charge. Accepted values: `stripe`,
`paypal`, `chargebee`.
A unique identifier for the charge. This can be the ID that the payment
gateway assigned to the charge.
A product ID string or a payment gateway integration object. Product IDs are
created by Corrily when you set up your Corrily account. Email
[support@corrily.com](mailto:support@corrily.com) if you don't know them. See the response of the [calculate
price](../calculate-price) endpoint for an example of the structure of
integration objects.
The status of the charge. Accepted values: `pending`, `succeeded`, `failed`.
A [User ID](../users/user-ids).
Free form key-value data. Metadata is useful for storing additional, structured information for a charge.
# Create Product
Source: https://docs.corrily.com/api-reference/create-product
POST https://client.corrily.com/v1/products
Create a Corrily product using an API instead of our dashboard.
```bash Bash theme={null}
curl --location -g --request POST 'https://client.corrily.com/v1/products' \
--header 'Content-Type: application/json' \
--data-raw '{
"api_id": "monthly",
"name": "Monthly Product",
"base_px": 10,
"interval": "month",
"interval_count": 1,
"country_prices": [
{
"country": "ES",
"amount": 50,
"currency": "EUR"
}
],
"integrations": [
{
"type": "stripe",
"stripe_product_id": "my_stripe_pid"
}
]
}'
```
```json Example theme={null}
{
"message": "Successfully created product.",
"success": true,
"api_id": "monthly",
"name": "Monthly Product",
"base_px": 10.0,
"baseline_id": null,
"country_prices": [
{
"country": "ES",
"local_price": 50.0,
"currency": "EUR"
}
],
"integrations": [
{
"type": "stripe",
"stripe_product_id": "my_stripe_pid"
}
]
}
```
## Body Params
The product identifier you will be calling this product with using [Corrily's
price endpoint](../api-reference/calculate-price).
The name of the product. Must be unique.
The base price of the product in `USD`.
A string value denoting how often to bill for a subscription. Possible values:
`day`, `week`, `month`, `year`, `one_time`.
An integer denoting how many intervals to bill for the. A monthly product
would have `month` as interval and `1` as interval counts, etc. One time
products should have an interval count of `1`.
A list of one ore more of the below country price object.
Two-letter ISO3166 country code.
The price of the product in this country.
The three-letter ISO4217 currency code of the price in this country.
A list of one or more of the below integration price objects. Not required in the case of a custom integration using the
[Subscription](../api-reference/create-subscription) and
[Charge](../api-reference/create-subscription) endpoints where Corrily product IDs are passed to alert us of
payment gateway revenue activity.
Should be set to equal `stripe`.
The matching [Stripe product ID](https://stripe.com/docs/api/products/object#product_object-id).
Should be set to equal `stripe_with_interval`.
The matching [Stripe product
ID](https://stripe.com/docs/api/products/object#product_object-id).
The frequency at which a subscription is billed. One of `day`, `week`,
`month` or `year`. Sometimes Stripe products actually encompass more than
what Corrily would consider a product. For example, the Stripe product for a
company's "Pro Plan" might have two [Price
objects](https://stripe.com/docs/api/prices/object) one for the monthly
version of the plan, the other for its annual version. Meanwhile, Corrily
would consider these to be two distinct products `pro_monthly` and
`pro_annual`. To capture such differences you can pass a
`stripe_with_interval` integration object which can help separate such
cases.
The number of intervals (specified in the interval attribute) between
subscription billings. For example, interval=month and interval\_count=3
bills every 3 months.
Should be set to equal `chargebee`.
The matching [Chargebee plan
ID](https://apidocs.chargebee.com/docs/api/plans?prod_cat_ver=1#plan_id).
Should be set to equal `recurly`.
The matching [Recurly plan
ID](https://developers.recurly.com/api/v2021-02-25/index.html#operation/create_plan).
Currency value
# Create subscription
Source: https://docs.corrily.com/api-reference/create-subscription
POST https://client.corrily.com/v1/subscriptions
Notify Corrily that one of your customers has started a subscription.
Custom payment gateway integrations only
You do not need to use this
endpoint if you have [granted Corrily automated
access](../payment-gateways/integration-guide#recommended-provide-automated-access-of-subscription-and-charge-events)
to your payment gateway's subscription and charge events.
## Body Params
The amount (price) of the subscription.
Users's two-letter ISO3166 country code.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the subscription was created. This timestamp should represent
when the subscription was initialized, regardless of the status of the
subscription during the initialization. It's rare to need to update created
after initially setting it.
The three-letter
([ISO4217](https://en.wikipedia.org/wiki/ISO_4217#Active_codes)) currency
code.
The payment gateway that handled the subscription. Accepted values: `stripe`,
`paypal`, `chargebee`
A unique identifier for the subscription. This can be the ID that the payment
gateway assigned to the subscription.
A product ID string or a payment gateway integration object. Product IDs are
created by Corrily when you set up your Corrily account. Email
[support@corrily.com](mailto:support@corrily.com) if you don't know them. See the response of the [calculate
price](../calculate-price) endpoint for an example of the structure of
integration objects.
The status of the subscription. Accepted values: `pending`, `trialing`,
`active`, `canceled`
A User ID.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the subscription will be canceled. In other words, the
customer will no longer have access to your service after this time. This
parameter should only be provided when `status` is set to `canceled`.
A 10-digit (seconds) unix timestamp indicating when customer expressed their
intent to cancel. This parameter should only be provided when `status` is set
to `canceled`.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the trial subscription ends. This parameter should only be
provided when `status` is set to `trialing`.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the trial subscription begins. This parameter should only be
provided when `status` is set to `trialing`.
```json Example theme={null}
{
"message": "[dev=False] subscription record 97#user123#stripe#origin789 was written.",
"success": true,
"record": {
"origin": "stripe",
"type": "subscription",
"latest_event_timestamp": 1628549872,
"latest_event_id": "corrily_evt_1628549872",
"corrily_product_id": 122,
"org_id": 97,
"origin_id": "origin789",
"user_id": "user123",
"created": 1628548983,
"interval": "month",
"interval_count": 1,
"status": "active",
"cancel_at": null,
"canceled_at": null,
"trial_start": null,
"trial_end": null,
"currency": null,
"amount": null,
"amount_usd": null,
"amount_usd_monthly": null
}
}
```
```bash Bash theme={null}
curl --request POST \
--url https://client.corrily.com/v1/subscriptions \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data '
{
"amount": 0,
"country": "string",
"created": 0,
"currency": "string",
"origin": "string",
"origin_id": "string",
"product": "Your product api_id",
"status": "string",
"user_id": "string",
"cancel_at": 0,
"canceled_at": 0,
"trial_end": 0,
"trial_start": 0
}
'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url = "https://client.corrily.com/v1/subscriptions";
const options = {
method: "POST",
headers: { Accept: "application/json", "Content-Type": "application/json" },
body: JSON.stringify({
amount: 0,
country: "string",
created: 0,
currency: "string",
origin: "string",
origin_id: "string",
product: "Your product api_id",
status: "string",
user_id: "string",
cancel_at: 0,
canceled_at: 0,
trial_end: 0,
trial_start: 0,
}),
};
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/subscriptions"
payload = {
"amount": 0,
"country": "string",
"created": 0,
"currency": "string",
"origin": "string",
"origin_id": "string",
"product": "Your product api_id",
"status": "string",
"user_id": "string",
"cancel_at": 0,
"canceled_at": 0,
"trial_end": 0,
"trial_start": 0
}
headers = {
"Accept": "application/json",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
```
# Delete charge
Source: https://docs.corrily.com/api-reference/delete-charge
DELETE https://client.corrily.com/v1/charges/{user_id}/{origin}/{origin_id}
```bash Bash theme={null}
curl --request DELETE \
--url https://client.corrily.com/v1/charges/user_id/origin/origin_id \
--header 'Accept: application/json'
```
## Path Params
The payment gateway that handled the charge. Accepted values: `stripe`,
`paypal`, `chargebee`.
A unique identifier for the charge. This can be the ID that the payment
gateway assigned to the charge.
The [User ID](../users/user-id) that you provided when you [created the
charge](./create-charge).
# Delete Product
Source: https://docs.corrily.com/api-reference/delete-product
DELETE https://client.corrily.com/v1/products/{product_api_id}
Delete an existing Corrily product.
```bash Bash theme={null}
curl --location --request DELETE 'https://client.corrily.com/v1/products/monthly'
```
```json Example theme={null}
{
"message": "Successfully deleted product my_new_product21",
"success": true
}
```
## Path Params
The api ID of the product.
# Delete subscription
Source: https://docs.corrily.com/api-reference/delete-subscription
DELETE https://client.corrily.com/v1/subscriptions/{user_id}/{origin}/{origin_id}
Delete Corrily's record of a subscription.
Custom payment gateway integrations only
You do not need to use this endpoint if you have [granted Corrily automated access](../payment-gateways/integration-guide#recommended-provide-automated-access-of-subscription-and-charge-events) to your payment gateway's subscription and charge events.
## Body Params
The amount (price) of the subscription.
Users's two-letter ISO3166 country code.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the subscription was created. This timestamp should represent
when the subscription was initialized, regardless of the status of the
subscription during the initialization. It's rare to need to update created
after initially setting it.
The three-letter ([ISO
4217](https://en.wikipedia.org/wiki/ISO_4217#Active_codes)) currency code.
The payment gateway that handled the subscription. Accepted values: `stripe`,
`paypal`, `chargebee`
A unique identifier for the subscription. This can be the ID that the payment
gateway assigned to the subscription.
A product ID string or a payment gateway integration object. Product IDs are
created by Corrily when you set up your Corrily account. Email
[support@corrily.com](mailto:support@corrily.com) if you don't know them. See the response of the [calculate
price](../calculate-price) endpoint for an example of the structure of
integration objects.
The status of the subscription. Accepted values: `pending`, `trialing`,
`active`, `canceled`
A User ID.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the subscription will be canceled. In other words, the
customer will no longer have access to your service after this time. This
parameter should only be provided when `status` is set to `canceled`.
A 10-digit (seconds) unix timestamp indicating when customer expressed their
intent to cancel. This parameter should only be provided when `status` is set
to `canceled`.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the trial subscription ends. This parameter should only be
provided when `status` is set to `trialing`.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the trial subscription begins. This parameter should only be
provided when `status` is set to `trialing`.
```json Example theme={null}
{
"message": "[dev=False] subscription record 97#user123#stripe#origin789 was written.",
"success": true,
"record": {
"origin": "stripe",
"type": "subscription",
"latest_event_timestamp": 1628549872,
"latest_event_id": "corrily_evt_1628549872",
"corrily_product_id": 122,
"org_id": 97,
"origin_id": "origin789",
"user_id": "user123",
"created": 1628548983,
"interval": "month",
"interval_count": 1,
"status": "active",
"cancel_at": null,
"canceled_at": null,
"trial_start": null,
"trial_end": null,
"currency": null,
"amount": null,
"amount_usd": null,
"amount_usd_monthly": null
}
}
```
```bash Bash theme={null}
curl --request DELETE \
--url https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id \
--header 'Accept: application/json'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url =
"https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id";
const options = { method: "DELETE", headers: { Accept: "application/json" } };
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id"
headers = {"Accept": "application/json"}
response = requests.delete(url, headers=headers)
print(response.text)
```
# Get All Products
Source: https://docs.corrily.com/api-reference/get-all-products
GET https://client.corrily.com/v1/products
Retrieve details of all Corrily products.
```bash Bash theme={null}
curl --location --request GET 'https://client.corrily.com/v1/products'
```
```json Example theme={null}
{
"message": "Successfully retrieved product.",
"success": true,
"products": [
{
"api_id": "monthly",
"name": "Monthly Product",
"base_px": 10.0,
"max_px": 999.0,
"min_px": 0.0,
"integrations": [
{
"type": "stripe",
"stripe_product_id": "my_stripe_pid"
}
]
},
{
"api_id": "yearly",
"name": "Yearly Product",
"base_px": 100.0,
"max_px": 9999.0,
"min_px": 100.0,
"integrations": [
{
"type": "stripe",
"stripe_product_id": "my_stripe_pid_yearly"
}
]
}
]
```
## Response
Whether or not the request completed successfully.
Text information about request status. In case of an error here will be a useful explanation.
List of all your products
Look for the product description on the page [Get Product](get-product).
# Get charge
Source: https://docs.corrily.com/api-reference/get-charge
GET https://client.corrily.com/v1/charges/{user_id}/{origin}/{origin_id}
```bash Bash theme={null}
curl --request GET \
--url https://client.corrily.com/v1/charges/user_id/origin/origin_id \
--header 'Accept: application/json'
```
## Path Params
The payment gateway that handled the charge. Accepted values: `stripe`,
`paypal`, `chargebee`.
A unique identifier for the charge. This can be the ID that the payment
gateway assigned to the charge.
The [User ID](../users/user-id) that you provided when you [created the
charge](./create-charge).
# Get Coupons
Source: https://docs.corrily.com/api-reference/get-coupons
GET https://client.corrily.com/v1/coupons
Retrieve a list of coupons
```bash Bash theme={null}
curl --location --request GET 'https://client.corrily.com/v1/coupons'
```
```bash Bash theme={null}
curl --location --request GET 'https://client.corrily.com/v1/coupons?name=Discount-1'
```
```json Example theme={null}
{
"message": "Successfully retrieved all coupons.",
"success": true,
"coupons": [
{
"api_id": "coupon_1",
"name": "Coupon_1",
"currency": null,
"coupon_type": {
"coupon_type": "percentage"
},
"value": 10,
"active_from": null,
"active_till": null,
"org": 1,
"status": "ACTIVE",
"created_at": "2024-01-17T09:40:18.058647+00:00",
"updated_at": "2024-01-17T09:40:18.058647+00:00",
"coupon_external_coupons": []
}
]
}
```
## Query Params
Filter coupons by name
## Response
Whether or not the request completed successfully.
Text information about request status. In case of an error here will be a useful explanation.
An array of found coupons
A coupon object
Coupon's api\_id value
Coupon's name
Coupon's currency. Can be null
Coupon\_type object
Can be:
* 'percentage' for coupons with discount in percents.
* 'fixed\_amount' for coupons with fixed discount
Coupon's value for discount
ISODate value since which a coupon can be applied.
ISODate value until which a coupon can be used.
Coupon's status. Can be: "ACTIVE" and "NOT\_ACTIVE"
Attached to coupon external coupons
An external coupon object
External coupon object
External coupon source. Can be: "STRIPE", "CHARGEBEE", "RECURLY"
# Get Paywall
Source: https://docs.corrily.com/api-reference/get-paywall
POST https://client.corrily.com/v1/paywall
Fetch Corrily Paywall content including Paywall design config, Plans to display, currency & price for each Plan by providing country, IP/user_id and other characteristics.
## Body Params
Optional. If you know user's id, you can pass it to stick the response to that user.
A two-letter (Alpha-2) [ISO 3166 country
code](https://en.wikipedia.org/wiki/List_of_ISO_3166_country_codes#Current_ISO_3166_country_codes).
Example: `US`
Optional. If you want to apply a specific paywall, you can pass it's id.
Optional product id to coupon id mapping to explicitly specify the coupon to be applied in the pricing. Coupons feature needs to be enabled for this. example `{"product_id_1": "coupon_id_1"}`. Multiple coupons can be applied by a comma-delimited string, for example: `{"product_id_1": "coupon_id_1,coupon_id2"}`
Will override the currency of any previously saved price and instead return
the price in the currency provided. If set to `true`, a `currency` param must
be passed. Unlike `override` the price amount will *not* be recomputed.
An object containing key-value pairs of arbitrary strings that represent features of this user which may affect their optimal price. See [User features](../users/02_user-features). Example: `{"platform": "ios"}`
If set to false, will make sure no experiment is run.
A currency you wish the price to be tied to. Currencies do not need to match
the passed country. For example, it is possible to return a price in EUR for
someone based in the Unites Sates. Note that the country-adjusted price will
be returned, regardless of the currency set.
## Usage
Paywall API is used by Corrily SDK libraries (e.g. [@corrily/react-sdk](/basics/00_introduction)) to fetch Paywall data.
This data is enough to render the complete Paywalls on customer's website or mobile app.
Response includes Paywall design configuration, set of Products to display, and price & currency for each Product.
The response depends on the user context (country, audience, characteristics) along with currently running experiments.
* `design configuration` - contains texts, colorus & layout config for visual customization
* `products` - set of products to show on Paywall. It comes from a Package, directly liked to a Paywall, or from a Packaging Segmentation config.
* `prices` - the same data, as the `/v1/prices` [API endpoint](/api-reference/calculate-price) response. Similarly to `/v1/prices` logic, once User see a Paywall, he'll be permanently sticked to the same design, set of plans and prices unless the `"override": true` parameter will be sent in the API request.
## Response
Whether or not the request completed successfully.
Id of the paywall
Is it a default paywall or not
Default buttons' caption
Default buttons' color
Background color
Should similar features in products be collapsed or not
Show product description
Header text abore the paywall
Text between title and paywall
Show header with description or not
Show annual discount percentage number near a monthly/annual switcher
Show feature comparison table below a paywall
Text on the button for showing feature comparison table
An object, where:
key - feature api id
value - badge title
Id of the product
Text unique id between organization's products
Name of the product
"month" or "year"
The period between payments
Optional
Optional
Optional
Optional
Optional
Optional
Id of the trial
Number of days provided by a trial
Type of the trial
Optional
Description override for a product in a paywall
Optional
Id of the feature
Text id of the feature
Feature type: "numeric", "boolean"
Feature's name
Optional. Value exists only for numeric features
Id of the feature value
Title for the unit
Optional
Feature description
Feature status: "draft", "active"
Feature status: "draft", "active"
Feature group id
Feature group name
Optional. Object with additional override info for a product
Optional. Override for a button caption of the product
Optional. Override for a button color of the product
Optional. Override for a description of the product
Optional. Override for a badge of the product
Optional. Override for a color of the product card
Optional. Url for a redirect on click the product's button
Optional. Flag: is product's price hidden, or not
Optional. Override for a product's price
# Get Product
Source: https://docs.corrily.com/api-reference/get-product
GET https://client.corrily.com/v1/products/{product_api_id}
Retrieve the details of a single Corrily product.
```bash Bash theme={null}
curl --location --request GET 'https://client.corrily.com/v1/products/monthly'
```
```json Example theme={null}
{
"message": "Successfully retrieved product.",
"success": true,
"api_id": "monthly",
"name": "Monthly Product",
"base_px": 10.0,
"max_px": 999.0,
"min_px": 0.0,
"baseline_id": null,
"product_trials": [],
"integrations": [
{
"type": "stripe",
"stripe_product_id": "my_stripe_pid",
"interval": "year",
"interval_count": 1
}
],
"country_prices": [
{
"country": "ES",
"local_price": 50.0,
"currency": "EUR"
}
],
"features": [
{
"api_id": "email_sync",
"name": "Full email sync with templates, open and click tracking and group emailing",
"description": "Full email sync with templates, open and click tracking and group emailing",
"status": "active",
"type": "boolean",
"unit": null,
"group_id": 1200,
"feature_group": {
"id": 1200,
"api_id": "collaboration",
"name": "Collaboration",
"description": ""
},
"value": 0
}
]
}
```
## Path Params
The api ID of the product.
## Response
Whether or not the request completed successfully.
Text information about request status. In case of an error here will be a useful explanation.
Product's corrily api\_id
Product's name
Product's base price in float format
ID of another product, considered as “baseline”.
It is used to calculate striked price(`price_with_baseline_strike`) in `/v1/prices` response.
A list of connected payment integrations (Stripe, Chargebee, ...)
Object, containts information about for a one payment integration
stripe\_with\_interval
Product id on the payment provider side
Payment interval (year, month)
Cadense of payments
A list of price objects for the given product
Object, containts information about for a one payment integration
Two-letter ISO3166 country code.
Price value
The three-letter ISO4217 currency code of the price in this country.
A list of features connected to the product
Feature object
Feature's corrily api\_id value
Feature's name
Feature's description
Feature's status (active, inactive)
Feature's status (active, inactive)
Feature's type (boolean, numeric)
Feature's measurement unit. Applicable only for numeric features. For boolean features equals null
Feature's threshold value. Applicable only for numeric features, for boolean always equals to 0
Feature's group id
Feature Group object
Feature's group id
Feature's group api\_d
Feature's group name
Feature's group description
# Get subscription
Source: https://docs.corrily.com/api-reference/get-subscription
GET https://client.corrily.com/v1/subscriptions/{user_id}/{origin}/{origin_id}
Retrieve the details of a single subscription for a single customer.
Custom payment gateway integrations only
You do not need to use this endpoint if you have [granted Corrily automated access](../payment-gateways/integration-guide#recommended-provide-automated-access-of-subscription-and-charge-events) to your payment gateway's subscription and charge events.
## Path Params
The payment gateway that handled the subscription. Accepted values: `stripe`,
`paypal`, `chargebee`
A unique identifier for the subscription. This can be the ID that the payment
gateway assigned to the subscription.
The [User ID](../users/user-characteristics) that you provided when you
[created the subscription](./create-subscription).
```json Example theme={null}
{
"success": true,
"subscription": {
"corrily_product_id2": 122,
"latest_event_id": "corrily_evt_1628549872",
"latest_event_timestamp": 1628549872,
"org_id": 97,
"origin": "stripe",
"origin_id": "origin789",
"type": "subscription",
"created": 1628548983,
"interval": "month",
"interval_count": 1,
"status": "active",
"user_id": "user123"
}
}
```
```bash Bash theme={null}
curl --request GET \
--url https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id \
--header 'Accept: application/json'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url =
"https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id";
const options = { method: "GET", headers: { Accept: "application/json" } };
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id"
headers = {"Accept": "application/json"}
response = requests.get(url, headers=headers)
print(response.text)
```
# Get User country
Source: https://docs.corrily.com/api-reference/get-user-details
GET https://client.corrily.com/v1/users/{user_id}
Get country for the user if the user exists.
This endpoint returns the country for the user if the user exists. If the user does not exist, it returns an 400 error.
## Path Params
A [User ID](../users/01_users).
## Body Params
## Response
Object containing user details
Country of the user
Details of the error if response is not a success response
Has the value false if the response is not a success
```
curl --request GET \
--url 'https://client.corrily.com/v1/users/test_user_id' \
--header 'Accept: application/json' \
--header 'Content-Type: application/json'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url = "https://client.corrily.com/v1/users/test_user_id";
const options = {
method: "GET",
headers: { Accept: "application/json", "Content-Type": "application/json" }
}),
};
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/users/test_user_id"
headers = {
"Accept": "application/json",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
```
```json Example theme={null}
{
"user": {
"country": "AU"
}
}
```
```json Example theme={null}
{
"success": false,
"error_message": "User does not exist"
}
```
# Identify Call
Source: https://docs.corrily.com/api-reference/set-user-characteristics
POST https://client.corrily.com/v1/identify
Link IPs to users and update user features.
The identify endpoint serves three purposes:
1. It can be used to pass user-level features after (or before) a price has already been tied to them using the [main price endpoint](api-reference/calculate-price).
2. It can be used to link IPs to user\_ids so that prices persist to a user as they see a price -> login in -> check the price again.
3. It is used during mobile integrations to inform Corrily about original [Apple](/integrations/02_apple-iap-integration) and [Google](/integrations/03_google-iap-integration) purchase IDs.
## Body Params
A [User ID](../users/01_users).
An IP you wish to tie the user to. For more information read our [anonymous users guide](../users/03_handling-anonymous-users).
Optional field which indicates the country which the user belongs to. If the country given is not part of the experiment for the ip user, the user id given
wont be added to the experiment via identify. Please note this country wont be stored against user. This is used only for validating
if the experiment characteristics for previous user from the ip can be applied to the user id.
The user country will be locked to the country given in subsequent price call.
An object containing arbitrary key-value pairs that represent characteristics
of this user which may affect their optimal price. The keys can be any valid
JSON key. The values can be strings, integers, or floats.
Pass an `original_transaction_id` for a user when they purchase an IAP product. (Note that in the backend, this will not overwrite any previously stored transaction IDs for this user).
Pass an `purchaseToken` for a user when they purchase an in-app product. (Note that in the backend, this will not overwrite any previously stored purchase tokens for this user).
## Response
Its an optional field. If the identify call copied experiment attributes from ip to the user, this attribute will be included in the response. Otherwise, it wont be included in the response.
```bash Bash theme={null}
curl --request POST \
--url https://client.corrily.com/v1/identify \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data '{ user_id: "string", features: {source: "youtube"} }'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url = "https://client.corrily.com/v1/identify";
const options = {
method: "POST",
headers: { Accept: "application/json", "Content-Type": "application/json" },
body: JSON.stringify({ user_id: "test_user", features: {"source": "youtube"} }),
};
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/identify"
payload = { "user_id": "test_user", "features": {"source": "youtube"} }
headers = {
"Accept": "application/json",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
```
```json Example theme={null}
{
"status": "ok"
}
```
# Update charge
Source: https://docs.corrily.com/api-reference/update-charge
POST https://client.corrily.com/v1/charges/{user_id}/{origin}/{origin_id}
```bash Bash theme={null}
curl --request POST \
--url https://client.corrily.com/v1/charges/user_id/origin/origin_id \
--header 'Content-Type: application/json'
```
## Path Params
The payment gateway that handled the charge. Accepted values: `stripe`,
`paypal`, `chargebee`.
A unique identifier for the charge. This can be the ID that the payment
gateway assigned to the charge.
The [User ID](/api-reference/users/user-id) that you provided when you
[created the charge](/api-reference/charges/create-charge).
## Body Params
The amount (price) of the charge.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the charge was created. This timestamp should represent when
the charge was initialized, regardless of the status of the charge during the
initialization. It's rare to need to update `created` after initially setting
it.
The three-letter [(ISO
4217\)](https://en.wikipedia.org/wiki/ISO_4217#Active_codes) currency code.
The status of the charge. Accepted values: `pending`, `succeeded`, `failed`.
Free form key-value data. Metadata is useful for storing additional, structured information for a charge.
# Update Product
Source: https://docs.corrily.com/api-reference/update-product
POST https://client.corrily.com/v1/products
Update the properties of a Corrily product.
```bash Bash theme={null}
curl --location -g --request POST 'https://client.corrily.com/v1/products/monthly' \
--header 'Content-Type: application/json' \
--data-raw '{
"name": "Monthly Product",
"base_px": 10,
"interval": "month",
"interval_count": 1,
"country_prices": [
{
"country": "ES",
"amount": 50,
"currency": "EUR"
}
],
"integrations": [
{
"type": "stripe",
"stripe_product_id": "my_stripe_pid"
}
]
}'
```
## Path Params
The name of the product. Must be unique.
## Body Params
The name of the product. Must be unique.
The base price of the product in `USD`.
A string value denoting how often to bill for a subscription. Possible values:
`day`, `week`, `month`, `year`, `one_time`.
An integer denoting how many intervals to bill for the. A monthly product
would have `month` as interval and `1` as interval counts, etc. One time
products should have an interval count of `1`.
A list of one ore more of the below country price object. *Country prices provided during an update call with overwrite any existing ones*.
Two-letter ISO3166 country code.
The price of the product in this country.
The three-letter ISO4217 currency code of the price in this country.
A list of one or more of the below integration price objects. *Integration objects provided during an update call with overwrite any existing ones*.
Should be set to equal `stripe`.
The matching [Stripe product
ID](https://stripe.com/docs/api/products/object#product_object-id).
Should be set to equal `stripe_with_interval`.
The matching [Stripe product ID](https://stripe.com/docs/api/products/object#product_object-id).
The frequency at which a subscription is billed. One of `day`, `week`, `month` or `year`.
Sometimes Stripe products actually encompass more than what Corrily would consider a product. For example,
the Stripe product for a company's "Pro Plan" might have two
[Price objects](https://stripe.com/docs/api/prices/object)
one for the monthly version of the plan, the other for its annual version. Meanwhile, Corrily would consider
these to be two distinct products `pro_monthly` and `pro_annual`. To capture such differences you can pass
a `stripe_with_interval` integration object which can help separate such cases.
The number of intervals (specified in the interval attribute) between subscription billings.
For example, interval=month and interval\_count=3 bills every 3 months.
Should be set to equal `chargebee`.
The matching [Chargebee plan
ID](https://apidocs.chargebee.com/docs/api/plans?prod_cat_ver=1#plan_id).
Should be set to equal `recurly`.
The matching [Recurly plan
ID](https://developers.recurly.com/api/v2021-02-25/index.html#operation/create_plan).
Currency value
# Update subscription
Source: https://docs.corrily.com/api-reference/update-subscription
POST https://client.corrily.com/v1/subscriptions/{user_id}/{origin}/{origin_id}
Notify Corrily that a subscription has changed.
Custom payment gateway integrations only
You do not need to use this endpoint if you have [granted Corrily automated access](../payment-gateways/integration-guide#recommended-provide-automated-access-of-subscription-and-charge-events) to your payment gateway's subscription and charge events.
## Path Params
The payment gateway that handled the subscription. Accepted values: `stripe`,
`paypal`, `chargebee`
A unique identifier for the subscription. This can be the ID that the payment
gateway assigned to the subscription.
The [User ID](../users/user-ids) that you provided when you [created the
subscription](./create-subscription).
## Body Params
The amount (price) of the subscription.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the subscription will be canceled. In other words, the
customer will no longer have access to your service after this time. This
parameter should only be provided when `status` is set to `canceled`.
A 10-digit (seconds) unix timestamp indicating when customer expressed their
intent to cancel. This parameter should only be provided when `status` is set
to `canceled`.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the subscription was created. This timestamp should represent
when the subscription was initialized, regardless of the status of the
subscription during the initialization. It's rare to need to update created
after initially setting it.
The three-letter ([ISO
4217](https://en.wikipedia.org/wiki/ISO_4217#Active_codes)) currency code.
The status of the subscription. Accepted values: `pending`, `trialing`,
`active`, `canceled`
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the trial subscription begins. This parameter should only be
provided when `status` is set to `trialing`.
A 10-digit (seconds) [UNIX timestamp](https://en.wikipedia.org/wiki/Unix_time)
indicating when the trial subscription ends. This parameter should only be
provided when `status` is set to `trialing`.
```json Example theme={null}
{
"message": "[dev=False] subscription record was written.",
"success": true,
"record": {
"origin": "stripe",
"type": "subscription",
"latest_event_timestamp": 1628609045,
"latest_event_id": "corrily_evt_1628609045",
"corrily_product_id": 122,
"org_id": 97,
"origin_id": "o123",
"user_id": "u123",
"created": null,
"interval": "month",
"interval_count": 1,
"status": "active",
"cancel_at": null,
"canceled_at": null,
"trial_start": null,
"trial_end": null,
"currency": null,
"amount": null,
"amount_usd": null,
"amount_usd_monthly": null
}
}
```
```bash Bash theme={null}
curl --request POST \
--url https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data '
{
"amount": 0,
"cancel_at": 0,
"canceled_at": 0,
"created": 0,
"currency": "string",
"status": "string",
"trial_start": 0,
"trial_end": 0
}
'
```
```js Node theme={null}
const fetch = require("node-fetch");
const url =
"https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id";
const options = {
method: "POST",
headers: { Accept: "application/json", "Content-Type": "application/json" },
body: JSON.stringify({
amount: 0,
cancel_at: 0,
canceled_at: 0,
created: 0,
currency: "string",
status: "string",
trial_start: 0,
trial_end: 0,
}),
};
fetch(url, options)
.then((res) => res.json())
.then((json) => console.log(json))
.catch((err) => console.error("error:" + err));
```
```python Python theme={null}
import requests
url = "https://client.corrily.com/v1/subscriptions/user_id/origin/origin_id"
payload = {
"amount": 0,
"cancel_at": 0,
"canceled_at": 0,
"created": 0,
"currency": "string",
"status": "string",
"trial_start": 0,
"trial_end": 0
}
headers = {
"Accept": "application/json",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
```
# Introduction
Source: https://docs.corrily.com/basics/00_introduction
Explore our guides and examples on how to implement Corrily.
Structured for efficiency, this resource helps you to master the Corrily Platform,
which includes Price Management and Price Experimentation.
While invaluable for those new to Corrily, this documentation also serves Pricing experts
seeking in-depth knowledge in specific aspects of their domain.
Navigate through the three main sections - Overview for Beginners, Integration Guides for Advanced
and the Specific Product-Feature sections.
Also note, we’ve fine-tuned ChatGPT 4 specifically on our Docs and API.
It might save you time and directly answer your questions.
Simply hit `Cmd` + `K` to start a dialog.
## For Beginners
If you're new to Corrily, start with the Basics section to grasp the core value proposition of the platform.
Then, move on to the Quickstart guides to understand how to set up a simple application.
Finally, look at the code samples on the Github Repo.
* [What is Corrily](/basics/01_what-is-corrily)
* [Corrily Architecture](/basics/02_corrily-architecture)
* [Quickstart on Web](/basics/02_quickstart-web)
* [Implementation Examples Github Repository](https://github.com/corrily/integration-examples)
## For Advanced Users
If you're well-versed, we recommend going over the Quickstart guides and our [architecture overview](/basics/02_corrily-architecture).
After that, dig into Integration Guides that align with your specific billing platforms or features of interest.
### Billing Platforms supported
* Stripe
* Chargebee
* Recurly
* Braintree
* Apple iOs
* Google Play
* Custom Integration (for any other platform)
Don’t want to spend time digging into the docs? Corrily team is always available for [**Technical Calls**](https://www.corrily.com/schedule-demo?utm_content=utm_content=docs),
where we discuss both integration processes and technical aspects.
The call is also an opportunity to share best practices in Price Experimentation and Price Management.
## Dive Deeper into Corrily's Platform
1. [Paywall Builder](/paywall-builder/configure): Learn to leverage Corrily's ready-made Paywalls UI to save development time.
2. [Price Management](/prices/01_country-prices): Understand how to efficiently manage and adjust your pricing and packaging, either globally or based on specific countries and audiences.
3. [Users](/users/01_users): Get to know how to manage your user base, including anonymous visitors, and how to setup audiences for more fine-grained pricing, experimentation and analytics.
4. [Experimentation](/experiments/01_experiment_design): Master the art of designing and running experiments to optimize almost every aspect of subscription monetization.
5. [Analytics](/experiments/08_experiment_analytics): Use Corrily's subscription analytics to save money on the separate analytics tool and build better understanding on how read experiment results to make data-driven decisions.
6. [Security and Privacy](/security_privacy/00_security_compliance): Rest assured that Corrily prioritizes security and minimizes the use of sensitive user data.
# What is Corrily?
Source: https://docs.corrily.com/basics/01_what-is-corrily
Know exactly how to price and package your products, services, subscriptions.
Today, digital businesses leave both money and users on the table owing to various challenges with their
pricing and packaging strategy viz:
* Slow and expensive price discovery
* Lack of visibility into willingness to pay across different markets and user segments
* Lack of resources when it comes to experimenting with pricing and packaging viz. trials and trial lengths, features,
plans shown etc.
* Inability to change prices without complex billing engineering
[Corrily](https://www.corrily.com/product-demo?utm_content=docs) solves these challenges by making it extremely simple for
business users to personalize paywalls for different user segments, run live experiments to find hidden monetization opportunities,
make real-time changes to prices and packages, as well as get automated pricing insights.
Corrily natively integrates with all major payment gateways, subscription management and commerce platforms,
allowing you to:
## Run live monetization experiments across platforms
* **Paywall Experiments** wherever you show a paywall, pricing page or product prices to your users - be it on your website, mobile app,
in-product or via marketing channels
* **Price Experiments** to test what prices optimize your revenue and conversion. Pricing tests can span simple tests such as testing individual prices or currencies of products, or more complex tests such as relative pricing of products
* **Packaging Experiments** to test what combination of products, features and trials work the best - for e.g. for an e-learning businesses students are more likely to buy short term plans such as a month-long plan, whereas professionals may be inclined to buy longer-term plans such as 3-months, or even an annual plan.
* **Discount Experiments** to test what discounts work the best for your objectives i.e. does 10% discount off work better than a flat \$10 discount?
## Understand Price Elasticity
* Study the impact of any experiment using Corrily's analytics dashboard or export analytics-ready tables into your own analytics or data warehouse platforms
* Understand your product's demand curve across your users using in-built analytics
* Monitor key downstream metrics such as revenue, ARPU, Trial and Paid Conversion, LTV, Average Order Value (AOV) etc.
## Offer Personalized Discounts
* Personalize discounts for every user based on user features such as their location, device type, acquisition channel, product engagement etc.
* Run promotional campaigns such as during holiday periods or during other key marketing moments
## Manage Prices at Scale
* Manage the prices of products, including handling of different currencies, FX conversions, local price formats, as well as price-niceness strategies
* Assign unique prices and coupons to individual users or groups (segments) of users
# Corrily Architecture
Source: https://docs.corrily.com/basics/02_corrily-architecture
Explore Corrily Platform components, Data Model and Control Flow.
## Architecture Overview
The Corrily Platform is designed to control and optimize almost every aspect of Pricing
and Monetization for subscription-based businesses. Its architecture consists of several key components,
including Pricing API, Analytics dashboard and Integrations.
### Paywall Builder
With Corrily, your pricing page becomes dynamic and remotely-configured, eliminating the need
for hardcoded prices. The content of the Pricing Page (including sets of plans to display, prices itself,
currencies, discounts, trial info, etc) will be fetched via API, which can be consumed either
by your back-end code or directly from the front-end or Mobile App using Corrily's SDKs.
That approach enables a personalized and dynamic pricing experience for each user.
### Price Management and Price Experimentation
Corrily serves as an external “admin panel” that controls your prices, acting
as a source of truth for pricing and monetization. It allows you to configure and immediately
apply every aspect of subscription monetization through the Corrily dashboard.
On each API call, the platform dynamically determines the country and audience of the User,
deciding if the User falls into an active experiment, and then responds with the appropriate
pricing page content for that User.
After displaying prices to the User, Corrily records the displayed values,
ensuring the User consistently encounters the same prices across the product and checkout pages,
and even on different platforms like on web or mobile app.
### Revenue Data Ingestion
To enable Corrily's analytics capabilities, it’s required to feed revenue events into the Corrily Platform
from your Subscription Management solution (Stripe Billing, Chargebee, Recurly or other).
Revenue events are typically fetched by Corrily itself using API Key or OAuth integration,
but it’s also possible to use Subscription Management Platform webhooks
or to feed revenue events using Corrily CRUD API.
In summary, the Corrily Platform architecture is designed to provide rich control
and optimization capabilities for different aspects of your pricing page.
By leveraging these components, you can create personalized pricing experiences for your users,
make data-driven decisions, and ultimately maximize revenue.
## Control Flow
There are typically multiple places where users could see or interact with your pricing page:
* **Anonymous pricing page**, publicly visible for unauthenticated website users or mobile app visitors
* **Internal Paywall or Customer Portal**, visible for signed users
* **Checkout Flow**, hosted by you, by subscription management platforms, or by IOS/Google Play
### Control Flow before Corrily
Before Corrily, companies typically use this simple setup:
* Paywall Plans and Prices are hardcoded on the front-end, or stored in the database
* Checkout prices are configured on the billing platform catalog
That means any update requires engineering effort, at least on the billing engineering side,
and, optionally, on front-end.
Also, that means there are risks of different types of inconsistencies.
### Control Flow with Corrily
With Corrily your Pricing Page becomes dynamic and controlled by the centralized monetization service.
As a centralized service, Corrily will ensure the following aspects:
* **Config correctness** - Corrily determines User’s country and audience in real-time to let Users see the appropriate prices configured for that country and audience
* **User Experience consistency** - Corrily ensures User will see the same set of plans, prices and currencies across all the places in the product and all the platforms
* **Checkout consistency -** Corrily ensures Users will pay the same price that they have seen
* **Features consistency -** Corrily ensures Users will always see the same set of features available in each plan
Here's a more detailed explanation of the Control Flow with Corrily Platform integrated:
1. **Anonymous Pricing Page**: When a user visits your anonymous pricing page, either your backend or the Corrily Front-End Software Development Kit (FE SDK) sends the user's IP address as a parameter to the **[Price request](/api-reference/calculate-price)**. The request would look like this:
```json theme={null}
{
"ip": "127.0.0.1"
}
```
Corrily then stores the prices served for that IP address. This ensures that if the same Visitor opens a pricing page again, he’ll see the same price.
2. **Internal Paywall**: Once the user signs in and visits the internal paywall, your backend needs to send both the `IP` address and the `user ID` to Corrily. This allows Corrily to associate the `IP` address with the `user ID` and maintain the same price that was previously shown to the unauthenticated Visitor. The request would look like this:
```json theme={null}
{
"ip": "127.0.0.1",
"user_id": "my_user_1"
}
```
If it's not possible to accurately determine the user's `IP` address at the time of visiting the internal paywall, you can associate the user with the `IP` address at the time of signup by sending an [Identify Request](/api-reference/set-user-characteristics) to Corrily with the `IP` address and `user ID`.
1. **Subscription Creation**: When creating a new subscription, you need to pass the price provided by Corrily to the Subscription Management Platform. This is typically done using `Overrides` (refer to the integration guides for each platform for more details)
By passing overrides, you ensure that the user will pay the price they saw, not the price hardcoded in the Subscription Management Platform catalog. This is particularly important during price experimentation, where different users might see different prices for the same plans.
2. **Successful Payment**: After a successful payment, the new subscription and charge rows will be automatically pulled by Corrily via data ingestion pipeline (for OAuth and API-Key integrations), or via webhook, and will appear in analytics on the next iteration of dashboard metrics recalculation.
## Corrily Data Model
### Paywall
Corrily **Paywall** is a fully functional front-end component, displaying plans, prices, coupons, and other entities from Corrily's Core.
Essentially, it's a payment page, rendered by [front-end SDK](/integrations/02_paywall-integration),
that dynamically displays prices from Corrily's Core for each specific user.
### Package
A Package means a set of plans to be displayed on the [Paywall](#paywall) depending on the user's location or other attributes.
It encapsulates several plans, all of which are displayed on the [Paywall](#paywall).
This abstraction simplifies management of which plan sets to show to which [Audience](#audience) and in which country.
### Product
Corrily **Product** represents a Plan or Addon User might subscribe to.
Typically, Corrily **Products** are mapped 1:1 to Plans or Addons from billing platforms.
### Price
Corrily **Price** is an entity which holds the `amount` and `currency` to be displayed for the selected [Product](#product)
in the selected country for the User's [Audience](#audience).
#### Fixed vs. Ephemeral prices
*The concept of ephemeral prices in Corrily.*
Corrily price can be either **fixed** or **ephemeral**.
#### Fixed Prices
A fixed price is a set *\* pair that is set
via the dashboard, or one of our CRUD API endpoints, and identifiable by a *price\_id* prefixed by `price_`. The amount set will match exactly the
display values returned by Corrily's API.
#### Ephemeral Prices
Ephemeral prices are the product of price transformations applied to fixed prices such as explicit applications of
rounding, calls for the price to be displayed in another currency, coupon applications, or price overrides.
Ephemeral prices too are identifiable by price IDs but these are prefixed by `eph_price_`.
### Trial Period
A **Trial Period** is an entity that allows the addition of a free or paid trial period to a [Product](#product).
The parameters of the **Trial Period** are configured separately from the [Product](#product) itself
and can be experimented with by attempting different **Trials** for different **Products**.
### Coupon
Corrily **Coupon** represents a discount option,
which allows giving a specific User a fixed or percentage discount on a [Product](#product).
Typically **Corrily Coupons** map 1:1 to the coupons on billing platforms.
### Product Feature
Product Feature represents a piece of functionality included into a specific [Product](#product).
Corrily allows to dynamically show different sets of features included into [Products](#product) on the [Paywall](#paywall).
### User
Corrily **User** represents physical person, who can see the price and can have one or several subscriptions,
each subscription comprises one or several products.
Typically Corrily **User** maps 1:1 to billing platform **Customer**.
### User Attribute
Corrily might store any custom metadata **Attributes** assigned to a [User](#user).
Those attribute values can be used to define [Audiences](#audience) by a variety of rules.
### Audience
Corrily allows to segment [Users](#user) based on the rules on top of [User Attributes](#user-attribute).
### Experiment
An **Experiment** is a single A-B-test, or Bayesian test, allowing comparison of different [Packages](#package),
[Prices](#price), striked "old" prices, [Trial Periods](#trial-period), discounts, [Features](#user-feature),
and other pricing attributes User can see.
# Coupons
Source: https://docs.corrily.com/coupons_and_campaigns/01_discount-coupons
How to create coupons to use when showing prices or running campaigns.
Corrily Coupons can be used to apply discounts to the products and subscriptions you offer. Coupons in Corrily can be either
a fixed amount coupon such as 10 USD or 1000 JPY, or a percentage off, such as 10% or 15% off
You can use coupons to:
* Apply discounts to every invoice or only one invoice
* Reduce invoice amounts by a percentage or a flat amount
* Apply discounts to every subscription a customer has or only specific ones
Create a Corrily Coupon
Create coupons on the Dashboard or with the API
**Creating a coupon on Corrily Dashboard:**
* On the Corrily Dashboard, open the Coupons page.
* Click "Create Corrily Coupon"
* In the dialog, enter the coupon parameters
* Click Create coupon.
Alternatively, you can also import coupons from other systems such as from Stripe or Chargebee. This creates and maps
corresponding Corrily coupons.
***
Here are all the **settings for coupons** that Corrily supports right now:
* **Name:** The name of the coupon that appears on receipts and invoices
* **API ID:** A unique identifier for the coupon in the API. Corrily auto generates this for you, but you can also change it
to your liking
* **Type:** Determines whether a coupon discounts a subscription by a fixed amount or by a percentage
* **Value:** Percentage off or Discount amount
* **Currency:** currency for Fixed Amount coupons
We will soon be adding support for `coupon expiration`, `coupon targeting` (i.e. certain coupon codes can only be applied
on certain products for e.g.),
# How to Design Experiment
Source: https://docs.corrily.com/experiments/01_experiment_design
How to target the correct subset of users to experiment on.
Corrily allows users to design and run [various types of experiments](/experiments/02_experimentation_platform).
This article will describe the general experimentation framework,
guide you through the process of setting up and running any type of experiment,
as well as analyzing the results and taking appropriate actions after the experiment was concluded.
## From Hypothesis to Experiment Design
Before running an experiment, it is important to **outline what hypothesis you want to test**.
This could mean running a single experiment or it could mean breaking down the hypothesis into multiple experiments. For e.g. if your hypothesis is that there may be **higher willingness to pay for your products in North America**, you may want to break down the hypothesis into two experiments - one experiment across US and Canada (since they are likely similar markets for your business), and another for Mexico.
If your hypothesis is a little more specific - say, there is higher willingness to pay amongst *professionals in North America*, it is best to [**define the relevant audience**](/segmentation/01_audiences) on the Corrily dashboard, and segment your experiment further. However, if you do not have a strong hypothesis, we recommend starting broad, learning from the experiment analytics so you can form some hypothesis, and then running more specific experiments.
Other important consideration when designing your experiment is to think through [**what cohorts of users do you want to experiment on**](#experiment-policy). Do you want to experiment solely on new users who have never seen your pricing page before, or you want to experiment with just the free user base.
There are all important considerations in deciding who to experiment on and setting your experiments up for success.
Corrily’s pricing experts are always available to help you think through these trade-offs
## Experiment Setup
### **Experiment Status Flow**
Every experiment undergoes a systematic Status Flow from drafting to conclusion. This flow represents the progressive steps from initial consideration of an experiment to its final results.
1. **Drafting the Experiment Configuration**
* At this stage, you simply draft the configuration of your experiment. It's worth noting that while in the draft state, the experiment remains inactive and only serves as a saved template for any future modifications.
2. **Manual Testing**
* Initially, set the experiment traffic to `0%`. This enables manual testing without affecting production users.
* With Corrily API, you can force experimental prices to be returned even when traffic is set at `0%`. Additionally, users can be directly assigned an experimental price via the User Page on the dashboard.
* **Traffic Allocation - Step 1**: Navigate to "Experiments" on the left menu and select the desired experiment. Once inside, scroll down and click on the "Traffic Allocation" edit icon as illustrated below.
* **Traffic Allocation - Step 2**: In the subsequent window, set your experiment traffic (`0%` in this instance). Options are available for either automatic traffic allocation per experiment arm or manual adjustments. Confirm your settings by clicking "Save."
3. **Activating the Experiment**
* Once satisfied, activate your experiment. The experimental prices will instantly be served to your users.
* Activation can be done by selecting the chosen experiment under the "Experiments" window and then clicking "Start Experiment."
4. **Pausing and Resuming**
* If necessary, experiments can be temporarily paused and then resumed at a later time.
5. **Concluding the Experiment**
* When you've gathered sufficient data and insights, you can conclude the experiment, ceasing its operations permanently.
**Recommendation**: Avoid rolling out the experiment to `100%` of your traffic immediately after manual testing. Instead, initiate with a gradual rollout, targeting `5-10%` of your traffic. Monitor for at least a day to ascertain whether users are subscribing at the experimental price and if operations are proceeding as anticipated. If all appears in order, you can then scale the traffic percentage to encompass `100%`.
### **Experiment Products**
The first step in setting up an experiment is to add the products you want to run the experiment for. These products can be any kind of subscription plan or addon (monthly/annual, basic/advanced) and can be defined in the Products tab of the Corrily dashboard
### **Experiment Targeting**
A crucial aspect of Experiment Setup Process is **experiment targeting**. Generally, there's no obligation to modify prices for your entire user base. In many instances, businesses differentiate pricing based on the countries they operate in. This distinction arises from variations in Purchasing Power Parity (PPP) across countries.
Thus, the primary configuration option for experiment setup pertains to targeting. It allows specification of countries (based on purchasing power or region) or the identification of distinct countries for the experiment. Additionally, the target audience can either encompass all users or be tailor-made to focus on a specific audience found under the 'User Management' tab. Further details on audience creation are available at [Segmentation Documentation](/segmentation/01_audiences).
Corrily's advanced filtering system facilitates this, allowing businesses to categorize countries based on Purchasing Power, Regional distinctions, or specific country-based criteria
User audience targeting can be broad, encompassing all users, or tailored to focus on a particular group. This specified group can be designed under the 'User Management' tab. For comprehensive guidelines on crafting a specific audience, please consult our [Audience Segmentation Documentation](/segmentation/01_audiences).
### **Experiment Policy**
A crucial configuration in your experiment setup is the **Experiment Policy**. There are two primary options available:
* **NEW\_USER\_ONLY**: This policy focuses exclusively on new users. The idea behind this strategy is to protect your existing user base, ensuring they are not subjected to unexpected price modifications. Those who have previously seen the price or have transitioned to paying customers will remain unaffected by the experiment. Typically, this "new users only" approach is the default, offering a risk-free method, as there's no chance of existing users identifying any package alterations.
* **NEW\_AND\_EXISTING\_USERS**: Sometimes, due to a limited influx of new users or perhaps operating over an extended period, there may arise a need to update packages for all users, including the existing ones. This strategy addresses that, allowing experimental packages to be showcased to both new users and existing users who haven't been part of any ongoing experiment. This implies that irrespective of any previous packages these users might have seen, Corrily will present the newly determined experimental packages to them.
It's vital to select a policy that aligns with your business goals and the expectations of your user base.
We have to be careful because Billing Platforms like Stripe permanently stick Customer to a currency at the time of Customer creation.
Once customer is created it'll be impossible for the customer to pay in the different currency, so it makes it impossible to do package experiments for existing users. To avoid technical issues here we're recommending do the **special preparation steps** to group already paid users into the separate Audience, and to exclude that Audience from any experiment.
### **Traffic Allocation Strategies**
The fourth key concept is **Traffic Allocation**. It's recommended to use the default `Automatic` option, which will split the traffic equally among arms. Think of it as about an AB test or about ABN test. Almost everybody wants to send the same amount of traffic to each arm, but sometimes if you don't have enough traffic or if you're already confident in your baseline price starts and sure, there're no risk of seasonality change, you might want to avoid sending traffic to baseline arm.
You might want to change the Traffic Split manually. For example to:
* decrease baseline arm traffic %
* or to completely disable some poorly performing arms
## **Steps Before Starting the Experiment**
### **Backfill Existing Users**
Before starting an experiment, it is recommended to backfill existing users into Corrily to avoid serving experimental prices to the existing user base. This also allows you to create an audience for existing paid customers and exclude them from any experiment to avoid currency issues.
The backfill of the small userbase could be done using [Identify API Endpoint](/api-reference/set-user-characteristics). More information about segmentation can be found in [Audiences](/segmentation/01_audiences).
The backfilling process of the large userbase requires expertise and better to be executed by the Corrily team. Should you need to undergo this phase, kindly reach out to us for assistance.
### **Mitigating the Risks**:
**Potential Risks of Price Experimentation**:
1. **Payment Currency Discrepancy**: One of the primary risks is the possibility of a returning paying user encountering an wrong currency when they revisit, thus hindering them from making subsequent payments.
2. **Perception of Inconsistent Pricing**: There exists a risk of existing users detecting a shift in pricing. Such inconsistencies can lead to discomfort or displeasure among them.
To counteract these risks, it's advisable to implement a backfill of existing users into the Corrily system prior to initiating any price experiments. Undertaking this step ensures that existing users aren't inadvertently subjected to new experimental pricing. Furthermore, once these users are backfilled, an Audience dedicated to current paid users can be constructed, allowing them to be exempted from experimental changes, thereby averting potential currency discrepancies.
## **Analyzing Experiment Results**
### Compare ARPU or predicted LTV across the Arms
Corrily provides the comprehensive set of charts to study the experimental prices performance on every stage of the user funnel:
* starting from conversion from free Visitors to the signed Users,
* then conversion to a trial period or to a first payment,
* and then the revenue metrics on how much did user pay over time,
* and finally the retention and charts
Using experiment Analytics you'll be able to analyze the every step of the funnel individually, or to see the final experimentation KPI metric projection (usually, the "Predicted LTV").
### Look at the over-time charts to study trends
Also want to note that Experiment Analytics has "Over-time charts", which might help you to experiment quicker. That charts help to study trends in conversion or revenue across arms. It's not rare experiment stats stop changing over time, means nothing is going to be changed in the future with a more data coming in, so, there's a signal to conclude the experiment faster.
## **Steps after Concluding the Experiment**
### **Rollout New Prices or Packages**
If the optimal arm wins, you may want to roll out the new prices to your entire user base in the experimental countries and for experimented audiences. To do this, update the prices in the Price Control Center and decide if you want to migrate existing users to allow them to see the updated prices or packages instead of the previous ones
### **Migrate Experimental Users Back to Baseline**
If the baseline arm wins, you may want to reset the experimental users back to the baseline price. This can be done via `Prices Migration`.
The migration of the users might be done using [Calculate Price API Endpoint](/api-reference/calculate-price) with the `"override": true` flag in payload.
The migration process of the large amount of users requires expertise and better to be executed by the Corrily team. Should you need to undergo this phase, kindly reach out to us for assistance.
## **Limitations and Tricky Moments**
You should be aware that Corrily Data Model assumes that a **single user** can be part of at most **one experiment at the time.**
If there're multiple experiments running simultaneously in the same country, even if they'll be testing the prices for the different products, it wouldn't be possible for the same user to participate in both experiments.
It's strongly recommended to run no more than a single experiment in the same country, or for the same Audience at a time.
# Corrily Experimentation Platform
Source: https://docs.corrily.com/experiments/02_experimentation_platform
An introduction to running experiments with Corrily
Why use Corrily for your pricing, packaging, discount and paywall experiments?
Corrily provides an end to end experimentation platform for all things pricing, packaging, discounts and paywalls.
Corrily's experimentation platform abstracts the complexity involved in running experiments in-house, and manages
everything for you. Moreover, our **machine learning models are pre-trained, and continuously improving** over time based
on your business-specific data and anonymous data across our entire customer base. This, in combination with our
**data-efficient sampling algorithms**, results in **30-40% improvement** in experiment convergence over traditional AB/n
experiments.
What can you manage using Corrily's experimentation platform?
Experiments in Corrily can be set-up and managed using our dashboard or the API:
* Defining the experiment objective
* Managing control and experiment treatments
* Orchestrating experiments i.e. traffic allocation, adding and disabling particular experiment treatments
* Measuring experiment results across most common metrics such as ARPU, LTV, Conversion, Retention, MRR, ARR etc.
* Calculating statistical significance and Confidence Intervals
* Post-experiment clean-up
* Rolling out winning experiment treatments
Different types of Experiments in Corrily
Corrily's Experimentation platform allows you to run various kinds of experiments.
* **Pricing Experiments:** to find the best price for a set of users. Pricing experiments can be used to test different price
points, different strikethrough prices, as well as price formatting i.e. price rounding strategies and currencies shown
* **Packaging Experiment:** to find the best combination of products and plans for a set of users. Packaging experiments
can also be used to test things such as different feature combinations for a product, different trial strategies etc.
* **Discount Experiments:** to find the optimal discount for a set of users. Discount experiments can be used to test optimal
discount percentages or amounts or coupons
Things to know before setting up an experiment
A few things to note while running an experiment with Corrily:
* **Experiment Objective:** Corrily supports various experiment objectives that you can choose from, such as
Optimizing ARPU, LTV, Conversion or Retention. Make sure you are selecting right experiment objective
* **Experiment Targeting:** Experiments can be run on a subset of products, countries and audiences. We recommend spending
some time thinking through the experiment architecture, especially if you plan on running multiple experiments. At Corrily, our
Pricing and Data Science experts are more than happy to consult.
* **Experiment States:** An experiment can have multiple states: `Draft`, `Ongoing`, `In Review`,`Paused` `Completed`. You can
set-up an experiment in the `Draft` state, submit it for `Review` before going live. Once an experiment is live, you can decide
to `Pause` an experiment (say during critical business periods), and `Resume` it later. Experiments can move to a `Completed`
state when they reach desired statistical significance, or can be forced to end subjectively
* **Traffic Allocation:** Experiment traffic allocation can be manual or dynamic i.e. optimized automatically by Corrily's machine
learning models
* An experiment in Corrily does not necessarily need to have a control group
# Experiment on Prices
Source: https://docs.corrily.com/experiments/03_price_experiments
How Corrily runs price experiments.
What is Price Experiment
In the Corrily platform, there exists a [variety of experimental techniques](/experiments/02_experimentation_platform).
The most common of them is **"Price Experimentation."** This methodology allows for the systematic variation of prices and currencies displayed to different users, even when considering the same subscription plans. Essentially, every user will view the same range of plans, but the prices for each plan, or a subset of them, may differ.
### Key Applications of Price Experimentation:
1. **Baseline vs. 10% Increase**: This experiment can be designed to compare the baseline price with a price that's increased by `10%`. This provides insights into user behavior and purchasing decisions when exposed to a minor price hike.
2. **Localized Prices vs. USD Prices**: In this experiment, one group of users is shown prices in their local currency, while another group views the prices in USD. This helps in understanding user preference and reception towards localized pricing as compared to standardized USD pricing.
How to setup Price Experiment
### 1. **Select Experiment Products**
Upon naming your experiment, the subsequent step is to determine the products that will be part of the experiment. This could encompass various subscriptions or packages, ranging from monthly to annual durations or from basic to advanced offerings. These product definitions are located in the 'Products' tab of our dashboard. For a comprehensive guide on product creation and management, refer to [Products documentation page](https://docs.corrily.com/prices/07_products_configuration).
### 2. Add Arms and set prices for Experimental Arms
Corrily experiments utilize the concept of arms. Think about it as about "AB tests on steroids". Experiment will have a couple of arms to test, which should include the single baseline arm to compare with. For any arm except baseline you would need to change prices and/or currencies. This price changes could be done in the Experiment Setup Interface, similar to Price Control Center. Here you can use bulk actions to modify the prices and can change prices for each country / audience individually.
In our example, we are starting a new experiment, and after filling the first page of information related to the experiment we reach the Define Arms step. Here we have a Baseline arm and we need to add at least one more to be able to proceed. Note that if you wish to delete the Baseline arm you can do that but you need to set another added arm as the new Baseline.
After the experiment arms are added, we can proceed to the Set Prices step. Here we can see the prices for each product-country pair that was created based on our previous choices. We also have different arms added so we can manipulate the prices for those arms. In order to do that, we will use the filters below and select the arm/arms that we are interested in.
For the first example, I will choose the `-10%` arm to change the prices for. Once selected, we have a checkbox that I can use to select all of the prices at once.
This is helpful as we can then perform bulk actions on the selected prices. In my case I will choose the **Generate X% Lower Prices** option to lower my prices in regards to the Baseline values.
| Bulk action | Description |
| ------------------------------------- | --------------------------------------------------------------------------------------------------- |
| Set Display Price | This action allows to change the displayed price and the currency for the selected prices |
| Switch Currency | This allows to change the currency the user will see for the selected prices |
| Change Display Price to Default Price | This will change the price seen by the user to the Baseline price |
| Generate Parity Prices | This action will generate new prices based on the purchasing power |
| Generate X% Higher Prices | This action will calculate the new price as % higher than the current baseline price and display it |
| Generate X% Lower Prices | This action will calculate the new price as % lower than the current baseline price and display it |
| Convert prices to local currencies | This will convert the price to the user local currency using locked FX rates |
| Convert prices to currency X | This allows the conversion of a price to a desired currency using locked FX rates |
If desired, the prices can be edited one by one by clicking on the edit icon on the right of each price. This will open the edit window where you have the option to change the country, price and currency as well as the option to use the local currency for that product-country pair.
All procedures and steps that are identical for both these experiments have been centralized for clarity and ease of reference.
For a comprehensive guide on these shared procedures, kindly refer to the [Experiment Design](/experiments/01_experiment_design) documentation. This ensures that you have access to the most consistent and up-to-date information, eliminating the need to browse through multiple pages for common methodologies.
# Experiment on Discounts
Source: https://docs.corrily.com/experiments/04_discount_experiments
How to run discount campaigns.
Besides running discount experiments, Corrily also supports the ability to run discount campaigns. Discount campaigns can
be used to:
* Run promotional campaigns during key marketing windows across multiple channels - such as site-wide banners, in-product
or emails
* Personalize the discounts rather than a flat X% off for everyone, based on user characteristics
Soon, we will be adding capability to render these discount strategies on site-wide banners, so you don't have to worry about building
banners and pop-ups on your own. You will not only be able to use Corrily as the backend optimization engine, but also use Corrily
to display these discounts on your web properties
# Experiment on Packages
Source: https://docs.corrily.com/experiments/05_packaging_experiments
How Corrily runs packaging experiments.
## **What is Packaging Experiment**
**Corrily's packaging experiments** allow you to test various packaging strategies for your entire user base or a subset of users to find out, what combination of products and plans work best for them. You can use a packaging experiment to test:
* Different combination of plans for e.g. say you have 4 tiers of your product offering - **`Basic, Pro, Team, Advanced`**. A packaging experiment allows you to test showing different combination of those plans to different users (including targeted segments), and decide what's the optimal combination
* A packaging experiment also allows you to test different copies, feature highlights etc. by creating different variants of the same plans say **`Basic VariantA`** v/s **`Basic VariantB`**
## How to setup Packaging Experiment
### 1. **Select Experiment Products**
Upon naming your experiment, the subsequent step is to determine the products that will be part of the experiment. This could encompass various subscriptions or packages, ranging from monthly to annual durations or from basic to advanced offerings. These product definitions are located in the 'Products' tab of our dashboard. For a comprehensive guide on product creation and management, refer to [Products documentation page](/prices/07_products_configuration).
### 2. Add Arms and select Packages for Axperimental Arms
Corrily experiments utilize the concept of arms. Think about it as about "AB tests on steroids". Experiment will have a couple of arms to test, which should include the single baseline arm to compare with. For any arm except baseline you would need to set the products you want in that specific package. could be done in the Experiment Setup Interface, similar to Price Control Center.
In our example, we are starting a new experiment, and after filling the first page of information related to the experiment we reach the Define Arms step. Here we have a Baseline arm and we need to add at least one more to be able to proceed. Note that if you wish to delete the Baseline arm you can do that but you need to set another added arm as the new Baseline.
After the experiment arms are added, we can proceed to define the arm packages. In this step for the previously set arms we will choose which of the products added to the experiment will be added to a package. This can be edited at all times ensuring a high flexibility for experimentation.
For the Baseline I only selected the Essential product and with each arm I have increased the products inside. This is exactly what the final user will see when they enter the page. If one of the arms needs editing, this can be done by clicking the Edit icon next to each arm and the following modal will open where we can modify the products inside the package.
All procedures and steps that are identical for both these experiments have been centralized for clarity and ease of reference.
For a comprehensive guide on these shared procedures, kindly refer to the [Experiment Design](/experiments/01_experiment_design) documentation. This ensures that you have access to the most consistent and up-to-date information, eliminating the need to browse through multiple pages for common methodologies.
# Recommendation Engine
Source: https://docs.corrily.com/experiments/05_recommendation_engine
Using Corrily as an independent recommendation engine for your prices and products.
Most customers use **Corrily for end to end price management** i.e. all the way from managing master prices across all products
and countries, as well as serving experimental or personalized prices. Since Corrily is able to abstract the complexity of
managing multiple sets of prices, which can also change over time, this simplifies price management exponentially for our
customers. However, if your master list of prices are deeply integrated with other enterprise workflows, and you are looking
to utilize Corrily's price optimization capabilities while still managing the master set of prices on your own, you can
use us as a **Recommendation Engine**.
Corrily as a Recommendation engine
Running Corrily as a Recommendation Engine for your prices as well as products is really straightforward:
* Instead of integrating prices returned by Corrily on your pricing interface, you can call Corrily in parallel with your
regular pricing flow.
* You would still be calling Corrily's APIs every time a price needs to be fetched, and pass all the relevant information i.e.
`User IPs`, `User IDs`, `Product IDs`, `Country`, `Coupons` and any additional user characteristics such as device, acquisition
channel etc.
* Corrily's recommended price can now be stored as an ephemeral price and displayed based on certain business logic at your
end
* You would still be feeding revenue events to Corrily using pertinent integration options for you
Here is an illustration of how the end to end flow would look.
**Note:** If you are using Corrily to optimize your paywall (i.e. optimizing which plans and products to display), you would still be
following the same set of steps.
# Experiment Analytics
Source: https://docs.corrily.com/experiments/08_experiment_analytics
How Corrily measures experiment success.
Corrily's Experimentation Platform supports fully self-serve analytics on the dashboard. For all kinds of experiments,
we provide the following analytics charts out of the box. Custom metrics can easily be added depending on your business
needs. Depending on your business model, some of these analytics charts may not apply to you. Corrily only shows charts
which are relevant to your business model.
* **A summary of key metrics** at the experiment level for a quick sanity check (across both control and experiment treatment groups)
* Number of visitors, users and paying users in the experiment
* What countries are the visitors coming in from
* Total Revenue, Average Revenue per user and Conversion Rate
* Breakdown of each treatment group - i.e. what products and prices are included across each arm in a pricing experiment etc.
* Which experiment treatment is *active* v/s *disabled*
***
* **Conversion Analytics** across each experiment treatment:
* Number of sign-ups
* Free to trial conversion
* Trial to paid conversion
[...]
